/*
Egy légitársaság az utasok rendelkezésére bocsátotta azoknak a földrajzi pontoknak a magasságait tar¬talmazó 
sorozatot, amelyek fölött a repülőgép száll majd Kolozsvár és New York között. Az a sorozat¬nak n darab 
(3 ≤ n ≤ 10 000), 30 000-nél szigorúan kisebb természetes szám eleme van. A szárazföld¬nek megfelelő pontok 
magasságai 0-tól különböznek, míg az óceánnak megfelelő pontok magasságai egyenlők 0-val. Szigetnek olyan 
egymás utáni szárazföldnek megfelelő pontok sorozatát nevezzük, amely előtt és után víz található. 
Az alábbi követelmények teljesítésére írjatok egy-egy algoritmust (alprogramot):
1.	Határozzátok meg a szigetek számát.
2.	Határozzátok meg a leghosszabb sziget kezdetét, valamint a végét jelző pont sorszámát. Ha több megoldás létezik, 
csak egyet kell meghatároznotok. Ha nem létezik egyetlen sziget sem, akkor az eredmény 0 0.
3.	Döntsétek el, hogy a leghosszabb sziget hegy típusú-e vagy sem. Egy sziget hegy típusú, ha a felszínén található 
magasságok egy adott elemig szigorúan növekvő – nem üres – sorozatot alkotnak, majd szigorúan csökkenőt, amely nem üres. 
4.	Döntsétek el, hogy a szárazföldnek megfelelő pontok magasságai páronként különböző értékűek vagy sem. 
5.	Ha a 4. pontban feltett kérdésre a válasz „nem”, határozzátok meg a leggyakoribb magasság értékét és az előfordulásainak számát. Ha több ilyen magasság létezik, csak egyet kell meg-adnotok.

*/

#include <iostream>
#include <fstream>

using namespace std;

ifstream f("szigetek2.in");

int const MAXDIM = 1001;
int const MAXDIM2 = 30001;

void beOlvas(int & n, int a[]){
// adatok beolvasása

  	f >> n;
  	for(int i = 1; i <= n; i++)
    	f >> a[i];
}

void kiIr(int & n, int a[]){
// a belvasott adatok kiírása 

  	cout << "n = " << n << endl;
  	cout << "A magassagok:" << endl;
  	for(int i = 1; i <= n; i++)
    	cout << a[i] << " ";
    cout << endl;
}

void repulesSzimulalasa(int n, int a[], int & szigetekSzama, int & maxKezd, int & maxVeg){
// meghatározzuk a leghosszabb pozitív számokból álló tömbszakaszt

int eleje, vege, i;

	maxKezd = 0;
	maxVeg = 0;	
	szigetekSzama = 0;								// még nem találtunk egy szigetet sem
	i = 1;
	while((i <= n) && (a[i] > 0)) 					// repülünk Európa fölött
      	i++;
	while(i <= n){									// ha nem ért véget az utazás
    	while((i <= n) && (a[i] == 0)){      		// repülünk az óceán fölött 
      		i++;
      	}
		eleje = i;  								// egy sziget kezdete, ha valóban sziget
    	while((i <= n) && (a[i] > 0)){ 				// repülünk a sziget fölött
      		i++;
      	}
		if(i < n){									// ha nem ért véget az utazás, vagyis legutoljára nem Amerika fölött repültünk
			szigetekSzama++;						// nõ a szigetek száma
			vege = i - 1;							// az aktuális sziget vége
			if(maxVeg - maxKezd <= vege - eleje){	// aktualizáljuk a legnagyobb szigetet
				maxKezd = eleje;
        		maxVeg = vege;
    		}
    	}
    }
}

bool hegyTulajdonsag(int eleje, int vege, int a[]){
// vizsgáljuk, hogy a sziget "hegy"-típusú-e

bool hegy;
int i = eleje;
	while((i < vege) and (a[i] < a[i+1]))					// vizsgáljuk, hogy a sorozat növekvő-e?
		i++;
	hegy = i < vege;										// ha a szigetnek nincs vége 
	if(hegy)
		while((i < vege) and (a[i] > a[i+1]))				// vizsgáljuk, hogy a sorozat csökkenő-e?
			i++;
	hegy = hegy and (i == vege);							// ha a sorozat egy darabig növekvő, majd csökkenő 
															// ha szigetnek vége, a sziget "hegy"
	return hegy;
}

bool kulonbozok_e(int n, int a[]){
// a magasságok különbözõségének vizsgálata

int i = 1;
bool kulonbozok = true;								// feltételezzük, hogy a magasságok különbözők
	while(kulonbozok && (i < n)){					// azért i < n, mert lennebb j = i + 1
		while(a[i] == 0)							// csak a szárazföldet vizsgáljuk
			i++;									// az óceán fölött "átsiklunk"
			
		int j = i + 1;								// az i. magasság a szárazföldön
		while((j <= n) && (a[i] != a[j]))			// amíg a magasságok különböznek, haladunk
			j++;

		kulonbozok = j > n;							// ha nem találtunk még egy a[i] magasságot, "kulonbozok" true lesz
		i++;										// áttérünk a különböző magasságra
	}	
	return kulonbozok;
}

void leggyakoribbMagassag(int n, int a[], int & magassag, int & k){
// a leggyakoribb magasság meghatározása: ez a "magassag" és k-szor fordul elõ

int elofordulas[MAXDIM2];
	
	for(int i = 1; i < MAXDIM2; i++)				// inicializáljuk a gyakoriság-tömböt
		elofordulas[i] = 0;
	for(int i = 1; i <= n; i++)						// aktualizáljuk a gyakoriságokat 
		elofordulas[a[i]]++;
	int max = 1;									// meghatározzuk a maximális gyakoriságot 
	for(int i = 1; i < MAXDIM2; i++)				
		if(elofordulas[i] > elofordulas[max])  
			max = i;
	magassag = max;									// "magassag" tárolja a maximális magasságot
	k = elofordulas[max];							// "k" tartalmazza a leggyakoribb magasság előfordulásainak számát
}

void kiirEredmeny(int szigetekSzama, int eleje, int vege, bool hegy, bool kulonbozok, int magassag, int k){
// az eredmények kiírása

	cout << "Szigetek szama: " << szigetekSzama << endl;
 	cout << "A legnagyobb sziget a(z) " << eleje << ". es a(z) " << vege << ". pontok kozott talalhato." << endl;

 	if(hegy)
 		cout << "Hegy." << endl;
	else
		cout << "Nem hegy." << endl;

    if(kulonbozok)
		cout << "A magassagok kulonboznek." << endl;
	else{
		cout << "A magassagok nem kulonboznek." << endl;
		cout << "A leggyakoribb magassag: " << magassag << " es " << k << "-szor fordul elo." << endl;	
	}
}

int main(){

int a[MAXDIM];         				// a magasságok sorozata
int n,               				// a magasságok száma
	szigetekSzama,                  // szigetek száma
	eleje,                   		// a legnagyobb sziget kezdetének sorszáma 
    vege,                        	// a legnagyobb sziget végének sorszáma
    magassag,						// a leggyakoribb magassag
    k;								// a leggyakoribb magassag elõfordulásainak száma

bool hegy, kulonbozok;

  	beOlvas(n, a);
  	kiIr(n, a);

// szigetek számának meghatározása és a legnagyobb sziget megkeresese  	
	repulesSzimulalasa(n, a, szigetekSzama, eleje, vege);
	
// a "hegy" tulajdonsag vizsgalata
	if(szigetekSzama != 0)						// ha van legalabb egy sziget
		hegy = hegyTulajdonsag(eleje, vege, a);

// a magasságok különbözõségének vizsgálata  
	kulonbozok = kulonbozok_e(n, a);
	if(!kulonbozok)
		leggyakoribbMagassag(n, a, magassag, k);		// a leggyakoribb magasság meghatározása		
	kiirEredmeny(szigetekSzama, eleje, vege, hegy, kulonbozok, magassag, k);
}
